; DescAPI for WhereIsIt?
; Original by Robert Galle
; ASM version by TBD/FeR

  MaxDescLength        equ 4096

  DT_Floppy525_360     equ 0
  DT_Floppy525_12      equ 1
  DT_Floppy35_720      equ 2
  DT_Floppy525_8SD     equ 3
  DT_Floppy525_8DD     equ 4
  DT_HardDisk          equ 5
  DT_TapeDrive         equ 6
  DT_Floppy35_144      equ 7
  DT_Optical           equ 8
  DT_Floppy35_288      equ 9
  DT_CDROM             equ 10
  DT_Network           equ 11
  DT_RamDisk           equ 12
  DT_Removable         equ 13
  DT_ZipDrive          equ 14
  DT_JazDrive          equ 15
  DT_ZipDrivePlus      equ 16
  DT_SeagateDirectTape equ 17
  DT_LS120             equ 18
  DT_MOS320            equ 19
  DT_MOS332            equ 20
  DT_M2531A            equ 21
  DT_Jaz2Drive         equ 22
  DT_Unknown           equ $FF

  ptReserved           equ 0
  ptSameFile           equ 1
  ptParentItem         equ 2
  ptItemList           equ 3
  ptDiskInfo           equ 4

  DescInfoRecord struct
    lpszRootPath              DWORD ?
    lpszVirtualRoot           DWORD ?
    lpszVolumeLabel           DWORD ?
    lpszFSName                DWORD ?
    iMaxNameLength            DWORD ?
    dwSerialNumber            DWORD ?
    wDiskNum                   WORD ?
    wMediaType                 WORD ?
    iBytesPerSector            BYTE ?
    iSectorsPerCluster         BYTE ?
    iTotalClusters             BYTE ?
    iFreeClusters              BYTE ?
    iNumberOfFiles             BYTE ?
    iNumberOfCompressedFiles   BYTE ?
    wNumberOfDirs              WORD ?
  DescInfoRecord ends

  ModuleInfo  PROCDESC STDCALL ModuleName :DWORD, Author :DWORD, Version :DWORD

  ConfigPluginProc PROCDESC STDCALL HInstance :DWORD, OwnerWnd :DWORD, \\
                   PluginID :DWORD
  
  RegisterPlugin PROCDESC STDCALL PluginID :WORD, PluginType :DWORD, \\
                 PluginName :DWORD, FileMask :DWORD, ConfigProc: DWORD

  RegisterDescPlugins PROCDESC STDCALL AddrRegisterPlugin :DWORD

  InitDescImport PROCDESC STDCALL

  DoneDescImport PROCDESC STDCALL

  RequireFileProc PROCDESC STDCALL FileName :DWORD
  
  ImportDesc_SameFile PROCDESC STDCALL PluginID :WORD, FileName :DWORD,\\
                      Desc: DWORD, RequireFile :DWORD

  ImportDesc_ParentItem PROCDESC STDCALL PluginID :WORD, ParentName :DWORD, \\
                        FoundList :DWORD, Desc :DWORD, RequireFile :DWORD

  StoreDescProc PROCDESC STDCALL FileName :DWORD, Desc :DWORD

  ImportDesc_ItemList PROCDESC STDCALL PluginID :WORD, ParentName :DWORD, \\
                      FoundList :DWORD, RequireFile :DWORD,  StoreDescProc :DWORD

  ImportDesc_DiskInfoProc PROCDESC STDCALL PluginID :WORD, \\
                          DescInfo: DescInfoRecord, Desc :DWORD